Scriptname aaaFaceLightAddScript extends Quest

; Spell Properties. 1 = Warm Light, 2 = Cool Light. D = Dim, B = Bright.

Spell Property aaaFaceLightSPEL1D auto

Spell Property aaaFaceLightSPEL1B auto

Spell Property aaaFaceLightSPEL2D auto

Spell Property aaaFaceLightSPEL2B auto

; MCM Name

String Property MCMName = "FaceLight" autoreadonly

; Player reference.

Actor Property PlayerREF auto

; Race Properties

Race Property HumanRace auto

Race property GhoulRace auto

; MCM Variables
; PC Light Variable
Int Property PCLightVar = 1 auto
; NPC Light Variable
Int Property NPCLightVar = 1 auto
; Dialogue Dist variable
Float Property DialogueDistance = 1000.0 auto

; Events
; On QuestScript Start
Event OnInit()
	self.Register()
	Utility.Wait(1)
	PlayerREF.AddSpell(aaaFaceLightSPEL1D, False)
	RegisterForDialogueMenu()
EndEvent

Event OnQuestInit()
	self.Register()
EndEvent

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	if (asMenuName == "DialogueMenu")
		If (abOpening)
			if (GetPlayerDialogueTarget().GetRace() == HumanRace || GetPlayerDialogueTarget().GetRace() == GhoulRace)
				if (NPCLightVar != 0)
					AddLightNPC()
					RegisterForDialogueMenu()
				endif
			endif
		else
			RemoveAllLightsNPC()
			RegisterForDialogueMenu()
		endif
	endif
EndEvent


; Functions
;Function LoadDefaultLight()
;	RemoveAllLightsPC()
;	Utility.Wait(1)
;	PCLightVar = 1
;	Utility.Wait(1)
;	RefreshLightPC()
;EndFunction

Function RefreshLightPC()
	If (PCLightVar == 1)
		RemoveAllLightsPC()
		Utility.Wait(2)
		PlayerREF.AddSpell(aaaFaceLightSPEL1D, false)
	elseif (PCLightVar == 2)
		RemoveAllLightsPC()
		Utility.Wait(2)
		PlayerREF.AddSpell(aaaFaceLightSPEL1B, false)
	elseif (PCLightVar == 3)
		RemoveAllLightsPC()
		Utility.Wait(2)
		PlayerREF.AddSpell(aaaFaceLightSPEL2D, false)
	elseif (PCLightVar == 4)
		RemoveAllLightsPC()
		Utility.Wait(2)
		PlayerREF.AddSpell(aaaFaceLightSPEL2B, false)
	elseif (PCLightVar == 0)
		RemoveAllLightsPC()
	Endif
EndFunction

Function RefreshLightNPC()
	If (NPCLightVar == 1)
		RemoveAllLightsNPC()
		Utility.Wait(2)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL1D, false)
	elseif (NPCLightVar == 2)
		RemoveAllLightsNPC()
		Utility.Wait(2)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL1B, false)
	elseif (NPCLightVar == 3)
		RemoveAllLightsNPC()
		Utility.Wait(2)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL2D, false)
	elseif (NPCLightVar == 4)
		RemoveAllLightsNPC()
		Utility.Wait(2)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL2B, false)
	elseif (NPCLightVar == 0)
		RemoveAllLightsNPC()
	Endif
EndFunction

Function AddLightNPC()
	If (NPCLightVar == 1)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL1D, false)
	elseif (NPCLightVar == 2)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL1B, false)
	elseif (NPCLightVar == 3)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL2D, false)
	elseif (NPCLightVar == 4)
		GetPlayerDialogueTarget().AddSpell(aaaFaceLightSPEL2B, false)
	Endif
EndFunction

Function RemoveAllLightsPC()
	PlayerREF.RemoveSpell(aaaFaceLightSPEL1D)
	PlayerREF.RemoveSpell(aaaFaceLightSPEL1B)
	PlayerREF.RemoveSpell(aaaFaceLightSPEL2D)
	PlayerREF.RemoveSpell(aaaFaceLightSPEL2B)
EndFunction

Function RemoveAllLightsNPC()
	Actor RemovalNPC
	Int iLoopCount = 10
	While iLoopCount > 0
		iLoopCount -= 1
		RemovalNPC = Game.FindRandomActorFromRef(PlayerREF, DialogueDistance + 1000.0)
		if RemovalNPC != PlayerREF
			RemovalNPC.RemoveSpell(aaaFaceLightSPEL1D)
			RemovalNPC.RemoveSpell(aaaFaceLightSPEL1B)
			RemovalNPC.RemoveSpell(aaaFaceLightSPEL2D)
			RemovalNPC.RemoveSpell(aaaFaceLightSPEL2B)
		EndIf
	EndWhile
		Return None
EndFunction

Function RegisterForDialogueMenu()
	RegisterForMenuOpenCloseEvent("DialogueMenu")
EndFunction

Actor Function GetPlayerDialogueTarget()
	Actor kPlayerDialogueTarget
	Int iLoopCount = 10
	While iLoopCount > 0
		iLoopCount -= 1
		kPlayerDialogueTarget = Game.FindRandomActorFromRef(PlayerREF , DialogueDistance)
		If kPlayerDialogueTarget != PlayerREF && kPlayerDialogueTarget.IsInDialogueWithPlayer() 
			Return kPlayerDialogueTarget
		EndIf
	EndWhile
        Return None
EndFunction

Function SetLightPC(int aiOption)
	If (aiOption == 0)
		PCLightVar = 0
	elseIf (aiOption == 1)
		PCLightVar = 1
	elseIf (aiOption == 2)
		PCLightVar = 2
	elseIf (aiOption == 3)
		PCLightVar = 3
	elseIf (aiOption == 4)
		PCLightVar = 4
	endif
endfunction

Function SetLightNPC(int aiOption)
	If (aiOption == 0)
		NPCLightVar = 0
	elseIf (aiOption == 1)
		NPCLightVar = 1
	elseIf (aiOption == 2)
		NPCLightVar = 2
	elseIf (aiOption == 3)
		NPCLightVar = 3
	elseIf (aiOption == 4)
		NPCLightVar = 4
	endif
endfunction

Function Register()
	RegisterForExternalEvent("OnMCMSettingChange|" + MCMName, "OnMCMSettingChange")
EndFunction

Function OnMCMSettingChange(string modName, string id)
	if (modName == MCMName)
		if (id == "PCLightVar")
			;Debug.Notification("PlayerFaceLight Changed")
			self.RefreshLightPC()
		elseif (id == "NPCLightVar")
			;Debug.Notification("NPCFaceLight Changed")
			self.RefreshLightNPC()
		endif
	endif
EndFunction
